/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Initial Developer of the Original Code is Soyapi Mumba.
 *
 * Portions created by the Initial Developer are Copyright (C) 2005,2006
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */
 
var SWOptions = {

	swServiceList: "",
	swEngineList: "",
	swNewEngineList: "",
	prefs: "",
	swPrefs: "", 
	svcPrefs: "",
	enginePrefs: "",
	swPrefsString: "extensions.searchwith.",

    onLoad: function() 
    {
        this.prefs = Components.classes["@mozilla.org/preferences-service;1"].
                    getService(Components.interfaces.nsIPrefService);  
        this.swPrefs = this.prefs.getBranch("extensions.searchwith.");
        this.svcPrefs = this.prefs.getBranch("extensions.searchwith.service-list.");				
        this.enginePrefs = this.prefs.getBranch("extensions.searchwith.engine-list.");		
        
        this.swServiceList = document.getElementById("searchwith-prefs-service-list");
        this.swEngineList = document.getElementById("searchwith-prefs-engine-list");
        this.swNewEngineList = document.getElementById("searchwith-prefs-new-service-engine");
        
        if (navigator.userAgent.search(/Thunderbird/gi) != -1) {
            var engineLoadMycroftBtn = document.getElementById("searchwith-prefs-engine-mycroftbtn");
            engineLoadMycroftBtn.hidden=true;
        }
        
        this.populateServices();
        this.populateEngines();
		centerWindowOnScreen();
    },
    
    addService: function() 
    {
        var newServiceName = "";
        var newServiceId = "";
        
        newServiceName = document.getElementById("searchwith-prefs-new-service").value;
        newServiceName.trim();
        if (newServiceName.length <1) {
            return;
        }
        
        newServiceId = SearchWith.createId(newServiceName);
        var tmpService = new SWService(newServiceId);
        if (tmpService.getName().length >0) {
            alert(SearchWith.getPropString("service.already.exists", "searchwith-strings"));
            return;
        }
        var li = this.swServiceList.appendItem(newServiceName, newServiceId);
        li.disabled = true;
    
        this.swServiceList.selectedItem = li;
        document.getElementById("searchwith-prefs-new-service").value = "";
        this.editService();
    
    }, 
    
    populateServices: function() 
    {
        var serviceName = "";
        var swServices = SearchWith.getServices();
         
        SearchWith.removeChildren(this.swServiceList);
        for (swService in swServices) {
            var aService = new SWService(swServices[swService]);
            if (swServices[swService].trim().length>0 && 
			    aService.getName().trim().length>0) {
                var aListItem = this.swServiceList.appendItem(aService.getName(), 
                                                        swServices[swService]);
                if (!aService.isEnabled()) {
                    aListItem.disabled = true;
                }
            }
        }
        this.swServiceList.selectItem(this.swServiceList.getItemAtIndex(0));
    },
    
    populateEngines: function() 
    {
        var swEngines = SearchWith.getEngines();
        SearchWith.removeChildren(this.swEngineList);
        for (each in swEngines) {
            var anEngine = new SWEngine(swEngines[each]);
            if (swEngines[each].trim().length >0 && 
			    anEngine.getName().trim().length>0) {
                this.swEngineList.appendItem(anEngine.getName(), swEngines[each]);
            }
        }
        this.swEngineList.selectItem(this.swEngineList.getItemAtIndex(0));
    },
    
    editService: function() 
    {
        var swsl = document.getElementById("searchwith-prefs-service-list");
        window.openDialog("chrome://searchwith/content/swOptionsService.xul","Service Options",
                      "chrome", swsl);
    },
    
    removeService: function() 
    {
        var swsl = this.swServiceList;
        if (!confirm(SearchWith.getPropString("permanently.delete", "searchwith-strings") + " " +
                    swsl.selectedItem.label + " " +
                    SearchWith.getPropString("service.qm", "searchwith-strings"))) {
            return;
        }
		
        var tmpConf = "";
        try {
			// don't delete branch if default pref value exists; the browser 
			// will load from default Prefs instead after restarting
			var swDefaultPrefs = prefs.getDefaultBranch("extensions.searchwith.");
			var serviceId = swsl.selectedItem.value;
			var tmpConf = swDefaultPrefs.getComplexValue("service-list."+serviceId,
                            Components.interfaces.nsISupportsString).data.trim();
			swPrefs.setCharPref("service-list."+serviceId, "");
			swPrefs.setCharPref("service."+serviceId+".label", "");
		} catch(e) {	
			try {
				if (tmpConf == "") {
					swPrefs.deleteBranch("service-list."+serviceId);
					swPrefs.deleteBranch("service."+serviceId);
				} 
			} catch(e2) {
				//alert(e2);
			}
        }
        swsl.removeItemAt(swsl.getIndexOfItem(swsl.selectedItem));
    },
    
    addEngine: function() 
    {
        var newEngineName = "";
        var newEngineId = "";
    
        newEngineName = document.getElementById("searchwith-prefs-new-engine").value;
        newEngineName = newEngineName.trim();
        if (newEngineName.length <1) {
            return;
        }
        
        newEngineId = SearchWith.createId(newEngineName);
        var newEngine = new SWEngine(newEngineId);
        if (newEngine.getName().length > 0) {
            alert(SearchWith.getPropString("engine.already.exists", "searchwith-strings"));
        }
        
        newEngine.setName(newEngineName);
        var eli = this.swEngineList.appendItem(newEngineName, newEngineId);
        this.swEngineList.selectedItem = eli;
        document.getElementById("searchwith-prefs-new-engine").value = "";
        this.editEngine();
    },
    
    editEngine: function() 
    {
        var swel = document.getElementById("searchwith-prefs-engine-list");;
        window.openDialog("chrome://searchwith/content/swOptionsEngine.xul","Edit Engine",
                      "chrome",swel);
    },
    
    removeEngine: function() 
    {
        var swel = this.swEngineList;
        if (!confirm(SearchWith.getPropString("permanently.delete", "searchwith-strings") + " " +
                    swel.selectedItem.label + " " +
                    SearchWith.getPropString("engine.qm", "searchwith-strings"))) {
            return;
        }
        
        // if engine to be deleted is being used by a search service, disable the service
        var swServices = SearchWith.getServices();
        for (each in swServices) {
            var aService = new SWService(swServices[each]);
            if (aService.getEngineId() == swel.selectedItem.value) {
                aService.setEngineId("");
            }
        }
            
        try {
            swPrefs.deleteBranch("engine-list."+swel.selectedItem.value);
            swPrefs.deleteBranch("engine."+swel.selectedItem.value);
            swel.removeItemAt(swel.getIndexOfItem(swel.selectedItem)); 
        } catch(e) {
        }
        
        this.populateServices();
        this.populateEngines();
    },
    
    checkAddServiceBtn: function() 
    {
        var newService = document.getElementById("searchwith-prefs-new-service").value;
        newService = newService.trim();
        if (newService.length <1) {
            document.getElementById("searchwith-prefs-add-service-button").disabled = true;
        } else {
            document.getElementById("searchwith-prefs-add-service-button").disabled = false;
        }
    },
    
    checkAddEngineBtn: function() 
    {
        var newEngine = document.getElementById("searchwith-prefs-new-engine").value;
        newEngine = newEngine.replace(/\s+/g,'');
        if (newEngine.length <1) {
            document.getElementById("searchwith-prefs-add-engine-button").disabled = true;
        } else {
            document.getElementById("searchwith-prefs-add-engine-button").disabled = false;
        }
    },
    
    restoreDefaults: function() 
    {
        var swel = this.swEngineList;
        if (!confirm(SearchWith.getPropString("restore.default.settings", "searchwith-strings"))) {
            return;
        }
		
		SearchWith.resetSettings();
		//SearchWith.importSearchBarEngines();
        SearchWith.doFirstRun();
        this.populateServices();
        this.populateEngines();
    },
    
    loadMycroftPlugins: function() 
	{    
        SearchWith.importSearchBarEngines();
        this.populateEngines();
    }

};
